﻿using System;
using System.Drawing;

namespace ImageToCode
{
    class Program
    {
        static void Main(string[] args)
        {
            var bitmap = new Bitmap(Image.FromFile(args[0]));
            var str = "const uint16_t picture[" + bitmap.Height.ToString()
                + "][" + bitmap.Width.ToString() + "] = { " + Environment.NewLine;
            for (int i = 0; i < bitmap.Height; ++i)
            {
                str += "{ ";
                for (int j = 0; j < bitmap.Width; ++j)
                {
                    uint argb = (uint)bitmap.GetPixel(j, bitmap.Height - 1 - i).ToArgb();
                    uint r = (argb >> (16 + 3)) & 0x1F;
                    uint g = (argb >> (8 + 2)) & 0x3F;
                    uint b = (argb >> (0 + 3)) & 0x1F;
                    ushort rgb = (ushort)((r << (6 + 5)) | (g << 5) | b);
                    str += "0x" + rgb.ToString("X4");
                    str += (j == bitmap.Width - 1) ? "" : ", ";
                }
                str += " }" + ((i == bitmap.Height - 1) ? "" : ",") + Environment.NewLine;
            }
            str += " };";
            var sw = new System.IO.StreamWriter(System.IO.Path.ChangeExtension(args[0], "txt"));
            sw.Write(str);
            sw.Close();
        }
    }
}
