#include "Adafruit_GFX.h"
#include "Adafruit_ST7735.h"
#include <FS.h>
#include <SD.h>
#include <WiFi.h>
#include <WiFiUdp.h>
WiFiUDP udp;

#define TFT_CS     5
#define TFT_RST    16
#define TFT_DC     17
#define SD_CS      4

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

uint16_t picture[120][160];
File file;

void setup(void) {
  SD.begin(SD_CS, SPI, 20000000);
  tft.initR(INITR_BLACKTAB);
  tft.fillScreen(ST7735_BLACK);
  udp.begin(10000);
  file = SD.open("Movie.dat");
}

void loop() {
  static bool play = false;
  if (udp.available()) {
    char s = udp.read();
    if (s == 'z') {
      if (!play) play = true;
      else play = false;
    }
    if (s == 'x') {
      play = false;
      file.seek(0);
      tft.fillScreen(ST7735_BLACK);
    }
  }
  if (play) {
    file.read((uint8_t*)picture, 120 * 160 * 2);
    tft.fillImage(picture, 0, 4, 160, 120);
    if (!file.available()) {
      play = false;
      file.seek(0);
      tft.fillScreen(ST7735_BLACK);
    }
  }
}

